/*
 * Copyright (c) 2012, Oracle and/or its affiliates. All rights reserved.
 */
package com.sun.javafx.tk.quantum;

import com.sun.glass.ui.ClipboardAssistance;
import com.sun.javafx.embed.EmbeddedSceneDragSourceInterface;
import java.util.Arrays;
import java.util.Set;
import java.util.concurrent.Callable;
import javafx.scene.input.TransferMode;

final class EmbeddedSceneDragSource implements EmbeddedSceneDragSourceInterface {

    private final EmbeddedSceneDnD dnd;
    private final GlassSceneDnDEventHandler dndHandler;

    public EmbeddedSceneDragSource(final EmbeddedSceneDnD dnd,
                                   final GlassSceneDnDEventHandler dndHandler) {
        this.dnd = dnd;
        this.dndHandler = dndHandler;
    }

    private ClipboardAssistance getClipboardAssistance() {
        assert dnd.isValid(this);
        return dnd.getClipboardAssistance(this);
    }

    @Override
    public Set<TransferMode> getSupportedActions() {
        assert dnd.isHostThread();
        return FxEventLoop.sendEvent(new Callable<Set<TransferMode>>() {

            @Override
            public Set<TransferMode> call() {
                return QuantumClipboard.clipboardActionsToTransferModes(getClipboardAssistance().
                        getSupportedSourceActions());
            }
        });
    }

    @Override
    public Object getData(final String mimeType) {
        assert dnd.isHostThread();
        return FxEventLoop.sendEvent(new Callable() {

            @Override
            public Object call() {
                return getClipboardAssistance().getData(mimeType);
            }
        });
    }

    @Override
    public String[] getMimeTypes() {
        assert dnd.isHostThread();
        return FxEventLoop.sendEvent(new Callable<String[]>() {

            @Override
            public String[] call() {
                return getClipboardAssistance().getMimeTypes();
            }
        });
    }

    @Override
    public boolean isMimeTypeAvailable(final String mimeType) {
        assert dnd.isHostThread();
        return (boolean) FxEventLoop.sendEvent(new Callable<Boolean>() {

            @Override
            public Boolean call() {
                return Arrays.asList(getClipboardAssistance().getMimeTypes()).
                        contains(mimeType);
            }
        });
    }

    @Override
    public void dragDropEnd(final TransferMode performedAction) {
        assert dnd.isHostThread();
        FxEventLoop.sendEvent(new Runnable() {

            @Override
            public void run() {
                try {
                    dndHandler.handleDragEnd(performedAction,
                                             getClipboardAssistance());
                } finally {
                    dnd.onDragSourceReleased(EmbeddedSceneDragSource.this);
                }
            }
        });
    }
}
